﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGHierarchicalDataTableTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataSet dataSet = new DataSet();

            DataTable parentTable = new DataTable();
            parentTable.Columns.Add("ID", typeof(int));
            parentTable.Columns.Add("Label", typeof(string));
            parentTable.Columns.Add("NumberOfChildFields", typeof(int));

            Random r = new Random();

            int currentMaxChildFields = 0;

            for(int i=0; i<10; i++)
            {
                int childFields = r.Next(3, 8);

                DataRow row = parentTable.NewRow();
                row[0] = i;
                row[1] = "Item " + i.ToString();
                row[2] = childFields;
                parentTable.Rows.Add(row);

                if(childFields > currentMaxChildFields)
                {
                    currentMaxChildFields = childFields;
                }
            }

            DataTable childTable = new DataTable();
            childTable.Columns.Add("ID", typeof(int));

            for(int i=0; i<currentMaxChildFields; i++)
            {
                childTable.Columns.Add("Child" + i.ToString(), typeof(string));
            }

            for(int i=0; i<10; i++)
            {
                DataRow parentRow = parentTable.Rows[i];
                int numberOfChildren = (int)parentRow[2];

                for(int j=0; j<5; j++)
                {                   
                    DataRow row = childTable.NewRow();
                    row[0] = i;

                    for(int k=0; k<numberOfChildren; k++)
                    {
                        row[k+1] = "Child " + k.ToString();
                    }

                    childTable.Rows.Add(row);
                }
            }

            dataSet.Tables.Add(parentTable);
            dataSet.Tables.Add(childTable);            

            DataRelation relation = new DataRelation("children", parentTable.Columns[0], childTable.Columns[0]);

            dataSet.Relations.Add(relation);

            xdg1.DataSource = parentTable.DefaultView;


        }
    }
}
